Slika 1: Struktura help datoteke
h_id           C7             Identifikator
h_name         C30            Naziv helpa
h_txt          M              Help tekst
h_x1           N2.0           Koordinate prozora
h_y1           N2.0           
h_x2           N2.0           
h_y2           N2.0           
h_index        L1             Da li informacija ulazi u indeks
h_ref          C70            Reference

Slika 2: Help sistem

PROC Help (cKey)
     LOCAL cSel, cHelp
     cSel := Select()
     USE Help INDEX Help NEW
     // Zadat je kljuc najviseg prioriteta
     IF cKey <> NIL
          cHelp := cKey
     // Zadat je globalni kljuc
     ELSEIF Type ("HelpKey") == "C"
     cHelp := HelpKey
     // Ne zna se kljuc
     ELSE
          cHelp := "NO_HELP"
     END IF
     WHILE cHelp <> NIL
          IF cHelp == "INDEX"
               cHelp := HelpIndex ()
          ELSE
               SEEK Upper(cHelp)
               cHelp := HelpShow (IIF (Found(), h_id, "NO_HELP"))
          END IF
     END DO
     CLOSE Help
     SELECT (cSel)
RETURN

STATIC FUNC HelpShow (cID)
LOCAL i, c, nRec, cRet, n, cRef
SEEK cID
IF Found()
     GetRef ()
     WIN CREATE aWin POS h_x1,h_y1,h_x2,h_y2
     WIN DISPLAY aWin
     HelpDisplay ()
     n := 1
     WHILE TRUE
          IF Len(aRef) <> 0
               @ nX2+n+1,nY1+3 SAY aMenu[n] COLOR "n/w"
               Ch := Inkey (0)
               @ nX2+n+1,nY1+3 SAY aMenu[n]
          ELSE
               Ch := Inkey (0)
          END IF
          DO CASE
          CASE Ch == K_ESC
               cRet := NIL
               EXIT
          CASE Ch == K_ENTER
               IF Len(aRef) > 0
                    cRet := aRef[n]
               ELSE
                    cRet := "INDEX"
               END IF
               EXIT
          CASE Ch == K_F1
               cRet := "INDEX"
               EXIT
          CASE Ch == K_DOWN
               IF ! ((c := MemoLine (h_txt,nLen,nBot+1)) == "")
                    nTop++ ; nBot++
                    Scroll (nX1,nY1,nX2,nY2,1)
                    @ nX2,nY1 SAY c
               END IF
               IF n < Len(aRef)
                    n++
               END IF
          CASE Ch == K_UP
               IF nTop > 1
                    nTop-- ; nBot--
                    Scroll (nX1,nY1,nX2,nY2,-1)
                    @ nX1,nY1 SAY MemoLine (h_txt,nLen,nTop)
                    END IF
               IF n > 1
                    n--
               END IF
          CASE Ch == K_ALT_RIGHT
               WIN CLOSE aWin
               Help->h_y2++
               WIN CREATE aWin POS h_x1,h_y1,h_x2,h_y2
               WIN DISPLAY aWin
               HelpDisplay ()
          CASE Ch == K_ALT_LEFT
               ...
          CASE Ch == K_ALT_DOWN
               ...
          CASE Ch == K_ALT_UP
               ...
          CASE Ch == K_CTRL_UP
               Help->h_x1--
               Help->h_x2--
               WIN MOVE aWin UP 1
               HelpDisplay ()
          CASE Ch == K_CTRL_DOWN
               ...
          CASE Ch == K_CTRL_RIGHT
               ...
          CASE Ch == K_CTRL_LEFT
               ...
          CASE Ch == K_F4
               Help->h_txt := MemoEdit (h_txt,nX1,nY1,nX2,nY2,TRUE)
               HelpDisplay ()
          CASE Ch == K_F5
               cSel := SelRef(h_ref)
               Help->h_ref := cSel
               GetRef ()
               HelpDisplay ()
          END CASE
     END DO
     WIN CLOSE aWin
END IF
RETURN cRet

STATIC FUNC SelRef (cRef)
LOCAL aWin, x1, x2, y1, y2, cRet, Ch
WIN OPEN aWin DIM 17,39
GetCor (aWin, @x1,@y1,@x2,@y2)
GO TOP
TB := TBrowseDB (x1+1,y1+2,x2-1,y2-2)
TB:addColumn (TBColumnNew ("", { || IIF (h_id $ cRet, "*", " ") + h_name } ))
cRet := cRef
WHILE TRUE
     WHILE !TB:stabilize() ; END DO
     Ch := Inkey(0)
     DO CASE
     CASE Ch == K_SPACE
          IF h_id $ cRet
               cRet := StrTran (cRet, h_id, "")
          ELSE
               cRet := h_id + cRet
          END IF
          TB:refreshCurrent():down()
     CASE Ch == K_ESC
          EXIT
     CASE Ch == K_DOWN
          TB:down()
     CASE Ch == K_UP
          TB:up()
     END CASE
END DO
WIN CLOSE aWin
RETURN cRet

STATIC PROC GetRef
aRef := {}
aMenu := {}
// Ima referenci
IF ! Empty(h_ref)
     nRec := RecNo()
     i := 1
     cRef := h_ref
     WHILE ! Empty(c := SubStr(cRef,i,7))
          SEEK c
          IF Found()
               AAdd (aRef, c)
               AAdd (aMenu, Trim(h_name))
          END IF
          i += 7
     END DO
     GO nRec
END IF
RETURN
